"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isRpcRequest = exports.isRpcEvent = exports.isRpcResponse = exports.isRpcPayload = void 0;
function isRpcPayload(rpc) {
    return rpc.jsonrpc === '2.0';
}
exports.isRpcPayload = isRpcPayload;
function isRpcResponse(rpc) {
    return isRpcPayload(rpc) && !rpc.method && rpc.id;
}
exports.isRpcResponse = isRpcResponse;
function isRpcEvent(rpc) {
    return isRpcPayload(rpc) && rpc.method && !rpc.id;
}
exports.isRpcEvent = isRpcEvent;
function isRpcRequest(rpc) {
    return isRpcPayload(rpc) && rpc.method && rpc.id;
}
exports.isRpcRequest = isRpcRequest;
