import { EventEmitter } from 'eventemitter3';
import { JsonRpcEvent, JsonRpcRequest } from './JsonRpc';
export interface JsonRpcRequestHolder {
    resolve: Function;
    reject: Function;
    payload: JsonRpcRequest;
    createdAt: Date;
}
export declare abstract class BasicChannel extends EventEmitter {
    abstract postMessage(rpc: JsonRpcRequest | JsonRpcEvent): void;
    responsePromiseHolder: {
        [key: string]: JsonRpcRequestHolder;
    };
    request(payload: Partial<JsonRpcRequest | JsonRpcEvent>): Promise<unknown>;
}
