import { Logger } from 'loglevel';
import { Env } from '../common/Env';
import { BasicChannel } from './BasicChannel';
import { JsonRpcResponse, JsonRpcEvent, JsonRpcRequest } from './JsonRpc';
export interface IChannel {
    postMessage: (data: string | any) => void;
}
/**
 * Native Channel
 */
export declare class NativeChannel extends BasicChannel implements IChannel {
    env: Env;
    log: Logger;
    requestChannel: string;
    constructor(requestChannel: string, logger: Logger, env: Env);
    /**
     * 将数据类型统一为 string
     */
    _dataToString(data: any): string;
    postMessage(data: JsonRpcRequest | JsonRpcEvent): void;
    CCPayNativeClientCallJS(msg: string | JsonRpcResponse | JsonRpcEvent): void;
}
