export interface JsonRpcRequest {
    jsonrpc: '2.0';
    method: string;
    params: object;
    id: string;
}
export interface JsonRpcEvent {
    jsonrpc: '2.0';
    method: string;
    params: object;
}
export interface JsonRpcResponse {
    jsonrpc: '2.0';
    result: object;
    error: {
        code: number;
        errorno?: string;
        message: string;
        data: object;
    };
    id: string;
}
export declare type JsonRpcPayload = JsonRpcEvent | JsonRpcRequest | JsonRpcResponse;
export declare function isRpcPayload(rpc: any): boolean;
export declare function isRpcResponse(rpc: any): rpc is JsonRpcResponse;
export declare function isRpcEvent(rpc: any): rpc is JsonRpcEvent;
export declare function isRpcRequest(rpc: any): rpc is JsonRpcRequest;
